/* document_view.c generated by valac 0.56.18, the Vala compiler
 * generated from document_view.vala, do not modify */

/* SPDX-FileCopyrightText: 2010-2020 Sébastien Wilmet
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <tepl/tepl.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gtex.h>
#include <gtksourceview/gtksource.h>
#include <gdk/gdk.h>
#include <gspell/gspell.h>
#include <glib/gi18n-lib.h>

#define DOCUMENT_VIEW_METADATA_KEY_SPELL_LANGUAGE "enter-tex-spell-language"
#define DOCUMENT_VIEW_METADATA_KEY_INLINE_SPELL "enter-tex-inline-spell"
#define DOCUMENT_VIEW_INLINE_SPELL_ENABLED_STR "1"
#define DOCUMENT_VIEW_INLINE_SPELL_DISABLED_STR "0"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DOCUMENT_VIEW (document_view_get_type ())
#define DOCUMENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT_VIEW, DocumentView))
#define DOCUMENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT_VIEW, DocumentViewClass))
#define IS_DOCUMENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT_VIEW))
#define IS_DOCUMENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT_VIEW))
#define DOCUMENT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT_VIEW, DocumentViewClass))

typedef struct _DocumentView DocumentView;
typedef struct _DocumentViewClass DocumentViewClass;
typedef struct _DocumentViewPrivate DocumentViewPrivate;
enum  {
	DOCUMENT_VIEW_0_PROPERTY,
	DOCUMENT_VIEW_NUM_PROPERTIES
};
static GParamSpec* document_view_properties[DOCUMENT_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))

#define TYPE_DOCUMENT (document_get_type ())
#define DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT, Document))
#define DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT, DocumentClass))
#define IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT))
#define IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT))
#define DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT, DocumentClass))

typedef struct _Document Document;
typedef struct _DocumentClass DocumentClass;

#define TYPE_COMPLETION_PROVIDER (completion_provider_get_type ())
#define COMPLETION_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPLETION_PROVIDER, CompletionProvider))
#define COMPLETION_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPLETION_PROVIDER, CompletionProviderClass))
#define IS_COMPLETION_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPLETION_PROVIDER))
#define IS_COMPLETION_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPLETION_PROVIDER))
#define COMPLETION_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPLETION_PROVIDER, CompletionProviderClass))

typedef struct _CompletionProvider CompletionProvider;
typedef struct _CompletionProviderClass CompletionProviderClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block18Data Block18Data;

struct _DocumentView {
	TeplView parent_instance;
	DocumentViewPrivate * priv;
};

struct _DocumentViewClass {
	TeplViewClass parent_class;
};

struct _DocumentViewPrivate {
	GSettings* _editor_settings;
	PangoFontDescription* _font_desc;
};

struct _Block18Data {
	int _ref_count_;
	DocumentView* self;
	GspellChecker* spell_checker;
};

static gint DocumentView_private_offset;
static gpointer document_view_parent_class = NULL;
static gboolean document_view__no_spell_language_dialog_shown;
static gboolean document_view__no_spell_language_dialog_shown = FALSE;

VALA_EXTERN GType document_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DocumentView, g_object_unref)
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
VALA_EXTERN GType document_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Document, g_object_unref)
VALA_EXTERN DocumentView* document_view_new (Document* doc);
VALA_EXTERN DocumentView* document_view_construct (GType object_type,
                                       Document* doc);
static void __lambda67_ (DocumentView* self,
                  GObject* d,
                  GParamSpec* p);
VALA_EXTERN gboolean document_get_readonly (Document* self);
static void ___lambda67__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void document_view_setup_font (DocumentView* self);
VALA_EXTERN GType completion_provider_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CompletionProvider, g_object_unref)
VALA_EXTERN CompletionProvider* completion_provider_get_default (void);
VALA_EXTERN GtkSourceCompletion* gtk_source_view_get_completion (GtkSourceView* self);
static void document_view_hide_completion_calltip_when_needed (DocumentView* self);
static void document_view_init_spell_checking (DocumentView* self);
static gboolean document_view_on_button_release_event (DocumentView* self,
                                                GdkEventButton* event);
static gboolean _document_view_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                 GdkEventButton* event,
                                                                                 gpointer self);
VALA_EXTERN void document_view_set_font_from_settings (DocumentView* self);
static void _document_view_set_font_from_settings_tepl_settings_font_changed (TeplSettings* _sender,
                                                                       gpointer self);
VALA_EXTERN void document_view_enlarge_font (DocumentView* self);
VALA_EXTERN void document_view_shrink_font (DocumentView* self);
VALA_EXTERN GFile* document_get_location (Document* self);
VALA_EXTERN GFile* document_get_main_file (Document* self);
static void __lambda68_ (DocumentView* self);
VALA_EXTERN void completion_provider_hide_calltip_window (CompletionProvider* self);
static void ___lambda68__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static GspellLanguage* document_view_get_spell_language (DocumentView* self);
VALA_EXTERN void document_view_setup_inline_spell_checker (DocumentView* self);
static void document_view_inline_checker_enabled_notify_cb (DocumentView* self);
static void _document_view_inline_checker_enabled_notify_cb_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self);
static void __lambda69_ (Block18Data* _data18_);
static void ___lambda69__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda70_ (Block18Data* _data18_);
static void ___lambda70__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda71_ (DocumentView* self);
static void ___lambda71__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static GspellChecker* document_view_get_spell_checker (DocumentView* self);
VALA_EXTERN void document_view_launch_spell_checker_dialog (DocumentView* self);
VALA_EXTERN void document_view_launch_spell_language_chooser_dialog (DocumentView* self);
VALA_EXTERN void document_view_save_spell_language_metadata (DocumentView* self);
VALA_EXTERN void document_set_metadata (Document* self,
                            const gchar* key,
                            const gchar* val);
VALA_EXTERN void document_view_save_inline_spell_metadata (DocumentView* self);
static void document_view_finalize (GObject * obj);
static GType document_view_get_type_once (void);

static inline gpointer
document_view_get_instance_private (DocumentView* self)
{
	return G_STRUCT_MEMBER_P (self, DocumentView_private_offset);
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 15 "../src/document_view.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 192 "document_view.c"
}

static void
__lambda67_ (DocumentView* self,
             GObject* d,
             GParamSpec* p)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 23 "../src/document_view.vala"
	g_return_if_fail (d != NULL);
#line 23 "../src/document_view.vala"
	g_return_if_fail (p != NULL);
#line 25 "../src/document_view.vala"
	_tmp0_ = document_get_readonly (G_TYPE_CHECK_INSTANCE_CAST (d, TYPE_DOCUMENT, Document));
#line 25 "../src/document_view.vala"
	_tmp1_ = _tmp0_;
#line 25 "../src/document_view.vala"
	gtk_text_view_set_editable ((GtkTextView*) self, !_tmp1_);
#line 212 "document_view.c"
}

static void
___lambda67__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 23 "../src/document_view.vala"
	__lambda67_ ((DocumentView*) self, _sender, pspec);
#line 222 "document_view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/document_view.vala"
	return self ? g_object_ref (self) : NULL;
#line 230 "document_view.c"
}

static gboolean
_document_view_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                        GdkEventButton* event,
                                                                        gpointer self)
{
	gboolean result;
	result = document_view_on_button_release_event ((DocumentView*) self, event);
#line 56 "../src/document_view.vala"
	return result;
#line 242 "document_view.c"
}

DocumentView*
document_view_construct (GType object_type,
                         Document* doc)
{
	DocumentView * self = NULL;
	GtexSettings* gtex_settings = NULL;
	GtexSettings* _tmp0_;
	GtexSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 19 "../src/document_view.vala"
	g_return_val_if_fail (doc != NULL, NULL);
#line 19 "../src/document_view.vala"
	self = (DocumentView*) g_object_new (object_type, NULL);
#line 21 "../src/document_view.vala"
	gtk_text_view_set_buffer ((GtkTextView*) self, (GtkTextBuffer*) doc);
#line 23 "../src/document_view.vala"
	g_signal_connect_object ((GObject*) doc, "notify::readonly", (GCallback) ___lambda67__g_object_notify, self, 0);
#line 28 "../src/document_view.vala"
	gtex_view_setup ((GtkSourceView*) self);
#line 30 "../src/document_view.vala"
	_tmp0_ = gtex_settings_get_singleton ();
#line 30 "../src/document_view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 30 "../src/document_view.vala"
	gtex_settings = _tmp1_;
#line 31 "../src/document_view.vala"
	_tmp2_ = gtex_settings_peek_editor_settings (gtex_settings);
#line 31 "../src/document_view.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 31 "../src/document_view.vala"
	_g_object_unref0 (self->priv->_editor_settings);
#line 31 "../src/document_view.vala"
	self->priv->_editor_settings = _tmp3_;
#line 33 "../src/document_view.vala"
	document_view_setup_font (self);
#line 282 "document_view.c"
	{
		CompletionProvider* provider = NULL;
		CompletionProvider* _tmp4_;
		GtkSourceCompletion* _tmp5_;
		GtkSourceCompletion* _tmp6_;
		GtkSourceCompletion* _tmp7_;
		GtkSourceCompletion* _tmp8_;
		GtkSourceCompletion* _tmp9_;
		GtkSourceCompletion* _tmp10_;
		GtkSourceCompletion* _tmp11_;
		GtkSourceCompletion* _tmp12_;
		GtkSourceCompletion* _tmp13_;
		GtkSourceCompletion* _tmp14_;
#line 38 "../src/document_view.vala"
		_tmp4_ = completion_provider_get_default ();
#line 38 "../src/document_view.vala"
		provider = _tmp4_;
#line 39 "../src/document_view.vala"
		_tmp5_ = gtk_source_view_get_completion ((GtkSourceView*) self);
#line 39 "../src/document_view.vala"
		_tmp6_ = _tmp5_;
#line 39 "../src/document_view.vala"
		gtk_source_completion_add_provider (_tmp6_, (GtkSourceCompletionProvider*) provider, &_inner_error0_);
#line 39 "../src/document_view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../src/document_view.vala"
			_g_object_unref0 (provider);
#line 310 "document_view.c"
			goto __catch0_g_error;
		}
#line 40 "../src/document_view.vala"
		_tmp7_ = gtk_source_view_get_completion ((GtkSourceView*) self);
#line 40 "../src/document_view.vala"
		_tmp8_ = _tmp7_;
#line 40 "../src/document_view.vala"
		g_object_set (_tmp8_, "remember-info-visibility", TRUE, NULL);
#line 41 "../src/document_view.vala"
		_tmp9_ = gtk_source_view_get_completion ((GtkSourceView*) self);
#line 41 "../src/document_view.vala"
		_tmp10_ = _tmp9_;
#line 41 "../src/document_view.vala"
		g_object_set (_tmp10_, "show-headers", FALSE, NULL);
#line 42 "../src/document_view.vala"
		_tmp11_ = gtk_source_view_get_completion ((GtkSourceView*) self);
#line 42 "../src/document_view.vala"
		_tmp12_ = _tmp11_;
#line 42 "../src/document_view.vala"
		g_object_set (_tmp12_, "auto-complete-delay", (guint) 0, NULL);
#line 43 "../src/document_view.vala"
		_tmp13_ = gtk_source_view_get_completion ((GtkSourceView*) self);
#line 43 "../src/document_view.vala"
		_tmp14_ = _tmp13_;
#line 43 "../src/document_view.vala"
		g_object_set (_tmp14_, "accelerators", (guint) 0, NULL);
#line 45 "../src/document_view.vala"
		document_view_hide_completion_calltip_when_needed (self);
#line 36 "../src/document_view.vala"
		_g_object_unref0 (provider);
#line 341 "document_view.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 36 "../src/document_view.vala"
		e = _inner_error0_;
#line 36 "../src/document_view.vala"
		_inner_error0_ = NULL;
#line 49 "../src/document_view.vala"
		_tmp15_ = e;
#line 49 "../src/document_view.vala"
		_tmp16_ = _tmp15_->message;
#line 49 "../src/document_view.vala"
		g_warning ("document_view.vala:49: Completion: %s", _tmp16_);
#line 36 "../src/document_view.vala"
		_g_error_free0 (e);
#line 361 "document_view.c"
	}
	__finally0:
#line 36 "../src/document_view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 36 "../src/document_view.vala"
		_g_object_unref0 (gtex_settings);
#line 36 "../src/document_view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 36 "../src/document_view.vala"
		g_clear_error (&_inner_error0_);
#line 36 "../src/document_view.vala"
		return NULL;
#line 374 "document_view.c"
	}
#line 53 "../src/document_view.vala"
	document_view_init_spell_checking (self);
#line 56 "../src/document_view.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) _document_view_on_button_release_event_gtk_widget_button_release_event, self, 0);
#line 19 "../src/document_view.vala"
	_g_object_unref0 (gtex_settings);
#line 19 "../src/document_view.vala"
	return self;
#line 384 "document_view.c"
}

DocumentView*
document_view_new (Document* doc)
{
#line 19 "../src/document_view.vala"
	return document_view_construct (TYPE_DOCUMENT_VIEW, doc);
#line 392 "document_view.c"
}

static void
_document_view_set_font_from_settings_tepl_settings_font_changed (TeplSettings* _sender,
                                                                  gpointer self)
{
#line 64 "../src/document_view.vala"
	document_view_set_font_from_settings ((DocumentView*) self);
#line 401 "document_view.c"
}

static void
document_view_setup_font (DocumentView* self)
{
	TeplSettings* tepl_settings = NULL;
	TeplSettings* _tmp0_;
	TeplSettings* _tmp1_;
#line 59 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/document_view.vala"
	document_view_set_font_from_settings (self);
#line 63 "../src/document_view.vala"
	_tmp0_ = tepl_settings_get_singleton ();
#line 63 "../src/document_view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 63 "../src/document_view.vala"
	tepl_settings = _tmp1_;
#line 64 "../src/document_view.vala"
	g_signal_connect_object (tepl_settings, "font-changed", (GCallback) _document_view_set_font_from_settings_tepl_settings_font_changed, self, 0);
#line 59 "../src/document_view.vala"
	_g_object_unref0 (tepl_settings);
#line 424 "document_view.c"
}

void
document_view_set_font_from_settings (DocumentView* self)
{
	gchar* font = NULL;
	TeplSettings* _tmp0_;
	gchar* _tmp1_;
	PangoFontDescription* _tmp2_;
	PangoFontDescription* _tmp3_;
#line 67 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/document_view.vala"
	_tmp0_ = tepl_settings_get_singleton ();
#line 69 "../src/document_view.vala"
	_tmp1_ = tepl_settings_get_selected_font (_tmp0_);
#line 69 "../src/document_view.vala"
	font = _tmp1_;
#line 70 "../src/document_view.vala"
	_tmp2_ = pango_font_description_from_string (font);
#line 70 "../src/document_view.vala"
	__vala_PangoFontDescription_free0 (self->priv->_font_desc);
#line 70 "../src/document_view.vala"
	self->priv->_font_desc = _tmp2_;
#line 71 "../src/document_view.vala"
	_tmp3_ = self->priv->_font_desc;
#line 71 "../src/document_view.vala"
	tepl_utils_override_font_description ((GtkWidget*) self, _tmp3_);
#line 67 "../src/document_view.vala"
	_g_free0 (font);
#line 455 "document_view.c"
}

void
document_view_enlarge_font (DocumentView* self)
{
	PangoFontDescription* _tmp0_;
	PangoFontDescription* _tmp1_;
	PangoFontDescription* _tmp2_;
#line 74 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/document_view.vala"
	_tmp0_ = self->priv->_font_desc;
#line 77 "../src/document_view.vala"
	_tmp1_ = self->priv->_font_desc;
#line 77 "../src/document_view.vala"
	pango_font_description_set_size (_tmp0_, pango_font_description_get_size (_tmp1_) + PANGO_SCALE);
#line 78 "../src/document_view.vala"
	_tmp2_ = self->priv->_font_desc;
#line 78 "../src/document_view.vala"
	tepl_utils_override_font_description ((GtkWidget*) self, _tmp2_);
#line 476 "document_view.c"
}

void
document_view_shrink_font (DocumentView* self)
{
	PangoFontDescription* _tmp0_;
	PangoFontDescription* _tmp1_;
	PangoFontDescription* _tmp2_;
#line 81 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/document_view.vala"
	_tmp0_ = self->priv->_font_desc;
#line 84 "../src/document_view.vala"
	_tmp1_ = self->priv->_font_desc;
#line 84 "../src/document_view.vala"
	pango_font_description_set_size (_tmp0_, pango_font_description_get_size (_tmp1_) - PANGO_SCALE);
#line 85 "../src/document_view.vala"
	_tmp2_ = self->priv->_font_desc;
#line 85 "../src/document_view.vala"
	tepl_utils_override_font_description ((GtkWidget*) self, _tmp2_);
#line 497 "document_view.c"
}

static gboolean
document_view_on_button_release_event (DocumentView* self,
                                       GdkEventButton* event)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 88 "../src/document_view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "../src/document_view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 91 "../src/document_view.vala"
	if (event->button == ((guint) 1)) {
#line 92 "../src/document_view.vala"
		_tmp0_ = (event->state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK;
#line 514 "document_view.c"
	} else {
#line 91 "../src/document_view.vala"
		_tmp0_ = FALSE;
#line 518 "document_view.c"
	}
#line 91 "../src/document_view.vala"
	if (_tmp0_) {
#line 522 "document_view.c"
		GtexSynctex* synctex = NULL;
		GtexSynctex* _tmp1_;
		GtexSynctex* _tmp2_;
		Document* doc = NULL;
		GtkTextBuffer* _tmp3_;
		GtkTextBuffer* _tmp4_;
		Document* _tmp5_;
		GtexSynctex* _tmp6_;
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		Document* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		Document* _tmp12_;
		GFile* _tmp13_;
		GFile* _tmp14_;
#line 94 "../src/document_view.vala"
		_tmp1_ = gtex_synctex_get_instance ();
#line 94 "../src/document_view.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 94 "../src/document_view.vala"
		synctex = _tmp2_;
#line 95 "../src/document_view.vala"
		_tmp3_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 95 "../src/document_view.vala"
		_tmp4_ = _tmp3_;
#line 95 "../src/document_view.vala"
		_tmp5_ = _g_object_ref0 (IS_DOCUMENT (_tmp4_) ? ((Document*) _tmp4_) : NULL);
#line 95 "../src/document_view.vala"
		doc = _tmp5_;
#line 96 "../src/document_view.vala"
		_tmp6_ = synctex;
#line 96 "../src/document_view.vala"
		_tmp7_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 96 "../src/document_view.vala"
		_tmp8_ = _tmp7_;
#line 96 "../src/document_view.vala"
		_tmp9_ = doc;
#line 96 "../src/document_view.vala"
		_tmp10_ = document_get_location (_tmp9_);
#line 96 "../src/document_view.vala"
		_tmp11_ = _tmp10_;
#line 96 "../src/document_view.vala"
		_tmp12_ = doc;
#line 96 "../src/document_view.vala"
		_tmp13_ = document_get_main_file (_tmp12_);
#line 96 "../src/document_view.vala"
		_tmp14_ = _tmp13_;
#line 96 "../src/document_view.vala"
		gtex_synctex_forward_search (_tmp6_, _tmp8_, _tmp11_, _tmp14_, (guint) event->time);
#line 96 "../src/document_view.vala"
		_g_object_unref0 (_tmp14_);
#line 91 "../src/document_view.vala"
		_g_object_unref0 (doc);
#line 91 "../src/document_view.vala"
		_g_object_unref0 (synctex);
#line 579 "document_view.c"
	}
#line 101 "../src/document_view.vala"
	result = FALSE;
#line 101 "../src/document_view.vala"
	return result;
#line 585 "document_view.c"
}

static void
__lambda68_ (DocumentView* self)
{
	CompletionProvider* provider = NULL;
	CompletionProvider* _tmp0_;
#line 108 "../src/document_view.vala"
	_tmp0_ = completion_provider_get_default ();
#line 108 "../src/document_view.vala"
	provider = _tmp0_;
#line 109 "../src/document_view.vala"
	completion_provider_hide_calltip_window (provider);
#line 106 "../src/document_view.vala"
	_g_object_unref0 (provider);
#line 601 "document_view.c"
}

static void
___lambda68__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 106 "../src/document_view.vala"
	__lambda68_ ((DocumentView*) self);
#line 611 "document_view.c"
}

static void
document_view_hide_completion_calltip_when_needed (DocumentView* self)
{
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
#line 104 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/document_view.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 106 "../src/document_view.vala"
	_tmp1_ = _tmp0_;
#line 106 "../src/document_view.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify::cursor-position", (GCallback) ___lambda68__g_object_notify, self, 0);
#line 627 "document_view.c"
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 115 "../src/document_view.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 115 "../src/document_view.vala"
	return _data18_;
#line 637 "document_view.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 115 "../src/document_view.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 647 "document_view.c"
		DocumentView* self;
#line 115 "../src/document_view.vala"
		self = _data18_->self;
#line 115 "../src/document_view.vala"
		_g_object_unref0 (_data18_->spell_checker);
#line 115 "../src/document_view.vala"
		_g_object_unref0 (self);
#line 115 "../src/document_view.vala"
		g_slice_free (Block18Data, _data18_);
#line 657 "document_view.c"
	}
}

static void
_document_view_inline_checker_enabled_notify_cb_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self)
{
#line 127 "../src/document_view.vala"
	document_view_inline_checker_enabled_notify_cb ((DocumentView*) self);
#line 668 "document_view.c"
}

static void
__lambda69_ (Block18Data* _data18_)
{
	DocumentView* self;
	GspellLanguage* _tmp0_;
#line 131 "../src/document_view.vala"
	self = _data18_->self;
#line 133 "../src/document_view.vala"
	_tmp0_ = document_view_get_spell_language (self);
#line 133 "../src/document_view.vala"
	gspell_checker_set_language (_data18_->spell_checker, _tmp0_);
#line 134 "../src/document_view.vala"
	document_view_setup_inline_spell_checker (self);
#line 684 "document_view.c"
}

static void
___lambda69__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 131 "../src/document_view.vala"
	__lambda69_ (self);
#line 694 "document_view.c"
}

static void
__lambda70_ (Block18Data* _data18_)
{
	DocumentView* self;
	GspellLanguage* _tmp0_;
#line 137 "../src/document_view.vala"
	self = _data18_->self;
#line 139 "../src/document_view.vala"
	_tmp0_ = document_view_get_spell_language (self);
#line 139 "../src/document_view.vala"
	gspell_checker_set_language (_data18_->spell_checker, _tmp0_);
#line 708 "document_view.c"
}

static void
___lambda70__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 137 "../src/document_view.vala"
	__lambda70_ (self);
#line 718 "document_view.c"
}

static void
__lambda71_ (DocumentView* self)
{
#line 144 "../src/document_view.vala"
	document_view_setup_inline_spell_checker (self);
#line 726 "document_view.c"
}

static void
___lambda71__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 142 "../src/document_view.vala"
	__lambda71_ ((DocumentView*) self);
#line 736 "document_view.c"
}

static void
document_view_init_spell_checking (DocumentView* self)
{
	Block18Data* _data18_;
	GspellLanguage* _tmp0_;
	GspellChecker* _tmp1_;
	GspellTextBuffer* gspell_buffer = NULL;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	GspellTextBuffer* _tmp4_;
	GspellTextView* gspell_view = NULL;
	GspellTextView* _tmp5_;
	GspellTextView* _tmp6_;
	Document* doc = NULL;
	GtkTextBuffer* _tmp7_;
	Document* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
#line 115 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/document_view.vala"
	_data18_ = g_slice_new0 (Block18Data);
#line 115 "../src/document_view.vala"
	_data18_->_ref_count_ = 1;
#line 115 "../src/document_view.vala"
	_data18_->self = g_object_ref (self);
#line 117 "../src/document_view.vala"
	_tmp0_ = document_view_get_spell_language (self);
#line 117 "../src/document_view.vala"
	_tmp1_ = gspell_checker_new (_tmp0_);
#line 117 "../src/document_view.vala"
	_data18_->spell_checker = _tmp1_;
#line 119 "../src/document_view.vala"
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 119 "../src/document_view.vala"
	_tmp3_ = _tmp2_;
#line 119 "../src/document_view.vala"
	_tmp4_ = gspell_text_buffer_get_from_gtk_text_buffer (_tmp3_);
#line 119 "../src/document_view.vala"
	gspell_buffer = _tmp4_;
#line 121 "../src/document_view.vala"
	gspell_text_buffer_set_spell_checker (gspell_buffer, _data18_->spell_checker);
#line 123 "../src/document_view.vala"
	document_view_setup_inline_spell_checker (self);
#line 125 "../src/document_view.vala"
	_tmp5_ = gspell_text_view_get_from_gtk_text_view (G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_text_view_get_type ()) ? ((GtkTextView*) self) : NULL);
#line 125 "../src/document_view.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 125 "../src/document_view.vala"
	gspell_view = _tmp6_;
#line 127 "../src/document_view.vala"
	g_signal_connect_object ((GObject*) gspell_view, "notify::inline-spell-checking", (GCallback) _document_view_inline_checker_enabled_notify_cb_g_object_notify, self, 0);
#line 129 "../src/document_view.vala"
	_tmp7_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 129 "../src/document_view.vala"
	_tmp8_ = _g_object_ref0 (IS_DOCUMENT (_tmp7_) ? ((Document*) _tmp7_) : NULL);
#line 129 "../src/document_view.vala"
	doc = _tmp8_;
#line 131 "../src/document_view.vala"
	g_signal_connect_data ((GObject*) doc, "notify::location", (GCallback) ___lambda69__g_object_notify, block18_data_ref (_data18_), (GClosureNotify) block18_data_unref, 0);
#line 137 "../src/document_view.vala"
	_tmp9_ = self->priv->_editor_settings;
#line 137 "../src/document_view.vala"
	g_signal_connect_data (_tmp9_, "changed::spell-checking-language", (GCallback) ___lambda70__g_settings_changed, block18_data_ref (_data18_), (GClosureNotify) block18_data_unref, 0);
#line 142 "../src/document_view.vala"
	_tmp10_ = self->priv->_editor_settings;
#line 142 "../src/document_view.vala"
	g_signal_connect_object (_tmp10_, "changed::highlight-misspelled-words", (GCallback) ___lambda71__g_settings_changed, self, 0);
#line 115 "../src/document_view.vala"
	_g_object_unref0 (doc);
#line 115 "../src/document_view.vala"
	_g_object_unref0 (gspell_view);
#line 115 "../src/document_view.vala"
	block18_data_unref (_data18_);
#line 115 "../src/document_view.vala"
	_data18_ = NULL;
#line 815 "document_view.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 832 "document_view.c"
}

static GspellLanguage*
document_view_get_spell_language (DocumentView* self)
{
	Document* doc = NULL;
	GtkTextBuffer* _tmp0_;
	Document* _tmp1_;
	gchar* lang_code = NULL;
	Document* _tmp2_;
	TeplMetadata* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GspellLanguage* _tmp10_;
	GspellLanguage* result;
#line 148 "../src/document_view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../src/document_view.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 150 "../src/document_view.vala"
	_tmp1_ = _g_object_ref0 (IS_DOCUMENT (_tmp0_) ? ((Document*) _tmp0_) : NULL);
#line 150 "../src/document_view.vala"
	doc = _tmp1_;
#line 152 "../src/document_view.vala"
	_tmp2_ = doc;
#line 152 "../src/document_view.vala"
	_tmp3_ = tepl_buffer_get_metadata ((TeplBuffer*) _tmp2_);
#line 152 "../src/document_view.vala"
	_tmp4_ = tepl_metadata_get (_tmp3_, DOCUMENT_VIEW_METADATA_KEY_SPELL_LANGUAGE);
#line 152 "../src/document_view.vala"
	lang_code = _tmp4_;
#line 153 "../src/document_view.vala"
	_tmp5_ = lang_code;
#line 153 "../src/document_view.vala"
	if (_tmp5_ == NULL) {
#line 870 "document_view.c"
		GSettings* _tmp6_;
		gchar* _tmp7_;
#line 154 "../src/document_view.vala"
		_tmp6_ = self->priv->_editor_settings;
#line 154 "../src/document_view.vala"
		_tmp7_ = g_settings_get_string (_tmp6_, "spell-checking-language");
#line 154 "../src/document_view.vala"
		_g_free0 (lang_code);
#line 154 "../src/document_view.vala"
		lang_code = _tmp7_;
#line 881 "document_view.c"
	}
#line 156 "../src/document_view.vala"
	_tmp8_ = lang_code;
#line 156 "../src/document_view.vala"
	if (string_get (_tmp8_, (glong) 0) == '\0') {
#line 157 "../src/document_view.vala"
		result = NULL;
#line 157 "../src/document_view.vala"
		_g_free0 (lang_code);
#line 157 "../src/document_view.vala"
		_g_object_unref0 (doc);
#line 157 "../src/document_view.vala"
		return result;
#line 895 "document_view.c"
	}
#line 159 "../src/document_view.vala"
	_tmp9_ = lang_code;
#line 159 "../src/document_view.vala"
	_tmp10_ = gspell_language_lookup (_tmp9_);
#line 159 "../src/document_view.vala"
	result = _tmp10_;
#line 159 "../src/document_view.vala"
	_g_free0 (lang_code);
#line 159 "../src/document_view.vala"
	_g_object_unref0 (doc);
#line 159 "../src/document_view.vala"
	return result;
#line 909 "document_view.c"
}

static GspellChecker*
document_view_get_spell_checker (DocumentView* self)
{
	GspellTextBuffer* gspell_buffer = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GspellTextBuffer* _tmp2_;
	GspellChecker* _tmp3_;
	GspellChecker* result;
#line 162 "../src/document_view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../src/document_view.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 164 "../src/document_view.vala"
	_tmp1_ = _tmp0_;
#line 164 "../src/document_view.vala"
	_tmp2_ = gspell_text_buffer_get_from_gtk_text_buffer (_tmp1_);
#line 164 "../src/document_view.vala"
	gspell_buffer = _tmp2_;
#line 167 "../src/document_view.vala"
	_tmp3_ = gspell_text_buffer_get_spell_checker (gspell_buffer);
#line 167 "../src/document_view.vala"
	result = _tmp3_;
#line 167 "../src/document_view.vala"
	return result;
#line 937 "document_view.c"
}

void
document_view_setup_inline_spell_checker (DocumentView* self)
{
	Document* doc = NULL;
	GtkTextBuffer* _tmp0_;
	Document* _tmp1_;
	gboolean enabled = FALSE;
	gchar* metadata = NULL;
	Document* _tmp2_;
	TeplMetadata* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GspellTextView* gspell_view = NULL;
	GspellTextView* _tmp8_;
	GspellTextView* _tmp9_;
#line 170 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/document_view.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 172 "../src/document_view.vala"
	_tmp1_ = _g_object_ref0 (IS_DOCUMENT (_tmp0_) ? ((Document*) _tmp0_) : NULL);
#line 172 "../src/document_view.vala"
	doc = _tmp1_;
#line 176 "../src/document_view.vala"
	_tmp2_ = doc;
#line 176 "../src/document_view.vala"
	_tmp3_ = tepl_buffer_get_metadata ((TeplBuffer*) _tmp2_);
#line 176 "../src/document_view.vala"
	_tmp4_ = tepl_metadata_get (_tmp3_, DOCUMENT_VIEW_METADATA_KEY_INLINE_SPELL);
#line 176 "../src/document_view.vala"
	metadata = _tmp4_;
#line 177 "../src/document_view.vala"
	_tmp5_ = metadata;
#line 177 "../src/document_view.vala"
	if (_tmp5_ != NULL) {
#line 975 "document_view.c"
		const gchar* _tmp6_;
#line 178 "../src/document_view.vala"
		_tmp6_ = metadata;
#line 178 "../src/document_view.vala"
		enabled = g_strcmp0 (_tmp6_, DOCUMENT_VIEW_INLINE_SPELL_ENABLED_STR) == 0;
#line 981 "document_view.c"
	} else {
		GSettings* _tmp7_;
#line 180 "../src/document_view.vala"
		_tmp7_ = self->priv->_editor_settings;
#line 180 "../src/document_view.vala"
		enabled = g_settings_get_boolean (_tmp7_, "highlight-misspelled-words");
#line 988 "document_view.c"
	}
#line 182 "../src/document_view.vala"
	_tmp8_ = gspell_text_view_get_from_gtk_text_view (G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_text_view_get_type ()) ? ((GtkTextView*) self) : NULL);
#line 182 "../src/document_view.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 182 "../src/document_view.vala"
	gspell_view = _tmp9_;
#line 184 "../src/document_view.vala"
	gspell_text_view_set_inline_spell_checking (gspell_view, enabled);
#line 170 "../src/document_view.vala"
	_g_object_unref0 (gspell_view);
#line 170 "../src/document_view.vala"
	_g_free0 (metadata);
#line 170 "../src/document_view.vala"
	_g_object_unref0 (doc);
#line 1004 "document_view.c"
}

void
document_view_launch_spell_checker_dialog (DocumentView* self)
{
	GspellNavigator* navigator = NULL;
	GspellNavigator* _tmp0_;
	GspellNavigator* _tmp1_;
	GspellCheckerDialog* dialog = NULL;
	GtkWindow* _tmp2_;
	GspellCheckerDialog* _tmp3_;
#line 187 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/document_view.vala"
	_tmp0_ = gspell_navigator_text_view_new (G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_text_view_get_type ()) ? ((GtkTextView*) self) : NULL);
#line 189 "../src/document_view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 189 "../src/document_view.vala"
	navigator = _tmp1_;
#line 191 "../src/document_view.vala"
	_tmp2_ = tepl_utils_get_toplevel_window ((GtkWidget*) self);
#line 191 "../src/document_view.vala"
	_tmp3_ = (GspellCheckerDialog*) gspell_checker_dialog_new (_tmp2_, navigator);
#line 191 "../src/document_view.vala"
	g_object_ref_sink (_tmp3_);
#line 191 "../src/document_view.vala"
	dialog = _tmp3_;
#line 194 "../src/document_view.vala"
	gtk_widget_show ((GtkWidget*) dialog);
#line 187 "../src/document_view.vala"
	_g_object_unref0 (dialog);
#line 187 "../src/document_view.vala"
	_g_object_unref0 (navigator);
#line 1038 "document_view.c"
}

void
document_view_launch_spell_language_chooser_dialog (DocumentView* self)
{
	GspellChecker* spell_checker = NULL;
	GspellChecker* _tmp0_;
	GspellChecker* _tmp1_;
	GspellLanguageChooserDialog* dialog = NULL;
	GtkWindow* _tmp2_;
	GspellLanguage* _tmp3_;
	GspellLanguageChooserDialog* _tmp4_;
	GspellLanguage* lang = NULL;
	GspellLanguage* _tmp5_;
#line 197 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/document_view.vala"
	_tmp0_ = document_view_get_spell_checker (self);
#line 199 "../src/document_view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 199 "../src/document_view.vala"
	spell_checker = _tmp1_;
#line 200 "../src/document_view.vala"
	g_return_if_fail (spell_checker != NULL);
#line 202 "../src/document_view.vala"
	_tmp2_ = tepl_utils_get_toplevel_window ((GtkWidget*) self);
#line 202 "../src/document_view.vala"
	_tmp3_ = gspell_checker_get_language (spell_checker);
#line 202 "../src/document_view.vala"
	_tmp4_ = (GspellLanguageChooserDialog*) gspell_language_chooser_dialog_new (_tmp2_, _tmp3_, (GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL) | GTK_DIALOG_USE_HEADER_BAR);
#line 202 "../src/document_view.vala"
	g_object_ref_sink (_tmp4_);
#line 202 "../src/document_view.vala"
	dialog = _tmp4_;
#line 209 "../src/document_view.vala"
	gtk_dialog_run ((GtkDialog*) dialog);
#line 211 "../src/document_view.vala"
	_tmp5_ = gspell_language_chooser_get_language ((GspellLanguageChooser*) dialog);
#line 211 "../src/document_view.vala"
	lang = _tmp5_;
#line 212 "../src/document_view.vala"
	gspell_checker_set_language (spell_checker, lang);
#line 214 "../src/document_view.vala"
	gtk_widget_destroy ((GtkWidget*) dialog);
#line 197 "../src/document_view.vala"
	_g_object_unref0 (dialog);
#line 197 "../src/document_view.vala"
	_g_object_unref0 (spell_checker);
#line 1087 "document_view.c"
}

void
document_view_save_spell_language_metadata (DocumentView* self)
{
	GspellChecker* spell_checker = NULL;
	GspellChecker* _tmp0_;
	GspellChecker* _tmp1_;
	GspellChecker* _tmp2_;
	Document* doc = NULL;
	GtkTextBuffer* _tmp3_;
	Document* _tmp4_;
	GspellLanguage* lang = NULL;
	GspellChecker* _tmp5_;
	GspellLanguage* _tmp6_;
	GspellLanguage* _tmp7_;
#line 217 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/document_view.vala"
	_tmp0_ = document_view_get_spell_checker (self);
#line 219 "../src/document_view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 219 "../src/document_view.vala"
	spell_checker = _tmp1_;
#line 220 "../src/document_view.vala"
	_tmp2_ = spell_checker;
#line 220 "../src/document_view.vala"
	g_return_if_fail (_tmp2_ != NULL);
#line 222 "../src/document_view.vala"
	_tmp3_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 222 "../src/document_view.vala"
	_tmp4_ = _g_object_ref0 (IS_DOCUMENT (_tmp3_) ? ((Document*) _tmp3_) : NULL);
#line 222 "../src/document_view.vala"
	doc = _tmp4_;
#line 224 "../src/document_view.vala"
	_tmp5_ = spell_checker;
#line 224 "../src/document_view.vala"
	_tmp6_ = gspell_checker_get_language (_tmp5_);
#line 224 "../src/document_view.vala"
	lang = _tmp6_;
#line 225 "../src/document_view.vala"
	_tmp7_ = lang;
#line 225 "../src/document_view.vala"
	if (_tmp7_ != NULL) {
#line 1132 "document_view.c"
		Document* _tmp8_;
		GspellLanguage* _tmp9_;
		const gchar* _tmp10_;
#line 226 "../src/document_view.vala"
		_tmp8_ = doc;
#line 226 "../src/document_view.vala"
		_tmp9_ = lang;
#line 226 "../src/document_view.vala"
		_tmp10_ = gspell_language_get_code (_tmp9_);
#line 226 "../src/document_view.vala"
		document_set_metadata (_tmp8_, DOCUMENT_VIEW_METADATA_KEY_SPELL_LANGUAGE, _tmp10_);
#line 1144 "document_view.c"
	} else {
		Document* _tmp11_;
#line 228 "../src/document_view.vala"
		_tmp11_ = doc;
#line 228 "../src/document_view.vala"
		document_set_metadata (_tmp11_, DOCUMENT_VIEW_METADATA_KEY_SPELL_LANGUAGE, NULL);
#line 1151 "document_view.c"
	}
#line 217 "../src/document_view.vala"
	_g_object_unref0 (doc);
#line 217 "../src/document_view.vala"
	_g_object_unref0 (spell_checker);
#line 1157 "document_view.c"
}

void
document_view_save_inline_spell_metadata (DocumentView* self)
{
	Document* doc = NULL;
	GtkTextBuffer* _tmp0_;
	Document* _tmp1_;
	GspellTextView* gspell_view = NULL;
	GspellTextView* _tmp2_;
	GspellTextView* _tmp3_;
	GspellTextView* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 231 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/document_view.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 233 "../src/document_view.vala"
	_tmp1_ = _g_object_ref0 (IS_DOCUMENT (_tmp0_) ? ((Document*) _tmp0_) : NULL);
#line 233 "../src/document_view.vala"
	doc = _tmp1_;
#line 235 "../src/document_view.vala"
	_tmp2_ = gspell_text_view_get_from_gtk_text_view (G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_text_view_get_type ()) ? ((GtkTextView*) self) : NULL);
#line 235 "../src/document_view.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 235 "../src/document_view.vala"
	gspell_view = _tmp3_;
#line 238 "../src/document_view.vala"
	_tmp4_ = gspell_view;
#line 238 "../src/document_view.vala"
	_tmp5_ = gspell_text_view_get_inline_spell_checking (_tmp4_);
#line 238 "../src/document_view.vala"
	_tmp6_ = _tmp5_;
#line 238 "../src/document_view.vala"
	if (_tmp6_) {
#line 1194 "document_view.c"
		Document* _tmp7_;
#line 240 "../src/document_view.vala"
		_tmp7_ = doc;
#line 240 "../src/document_view.vala"
		document_set_metadata (_tmp7_, DOCUMENT_VIEW_METADATA_KEY_INLINE_SPELL, DOCUMENT_VIEW_INLINE_SPELL_ENABLED_STR);
#line 1200 "document_view.c"
	} else {
		Document* _tmp8_;
#line 244 "../src/document_view.vala"
		_tmp8_ = doc;
#line 244 "../src/document_view.vala"
		document_set_metadata (_tmp8_, DOCUMENT_VIEW_METADATA_KEY_INLINE_SPELL, DOCUMENT_VIEW_INLINE_SPELL_DISABLED_STR);
#line 1207 "document_view.c"
	}
#line 231 "../src/document_view.vala"
	_g_object_unref0 (gspell_view);
#line 231 "../src/document_view.vala"
	_g_object_unref0 (doc);
#line 1213 "document_view.c"
}

static void
document_view_inline_checker_enabled_notify_cb (DocumentView* self)
{
	GspellTextView* gspell_view = NULL;
	GspellTextView* _tmp0_;
	GspellTextView* _tmp1_;
	GspellTextView* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GspellChecker* spell_checker = NULL;
	GspellChecker* _tmp5_;
	GspellChecker* _tmp6_;
	GspellChecker* _tmp7_;
	GspellChecker* _tmp8_;
	GspellLanguage* _tmp9_;
	GspellTextView* _tmp10_;
	GtkMessageDialog* dialog = NULL;
	GtkWindow* _tmp11_;
	GtkMessageDialog* _tmp12_;
	GtkMessageDialog* _tmp13_;
	gint response = 0;
	GtkMessageDialog* _tmp14_;
	GtkMessageDialog* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 248 "../src/document_view.vala"
	g_return_if_fail (self != NULL);
#line 250 "../src/document_view.vala"
	_tmp0_ = gspell_text_view_get_from_gtk_text_view (G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_text_view_get_type ()) ? ((GtkTextView*) self) : NULL);
#line 250 "../src/document_view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 250 "../src/document_view.vala"
	gspell_view = _tmp1_;
#line 252 "../src/document_view.vala"
	_tmp2_ = gspell_view;
#line 252 "../src/document_view.vala"
	_tmp3_ = gspell_text_view_get_inline_spell_checking (_tmp2_);
#line 252 "../src/document_view.vala"
	_tmp4_ = _tmp3_;
#line 252 "../src/document_view.vala"
	if (!_tmp4_) {
#line 253 "../src/document_view.vala"
		_g_object_unref0 (gspell_view);
#line 253 "../src/document_view.vala"
		return;
#line 1260 "document_view.c"
	}
#line 255 "../src/document_view.vala"
	_tmp5_ = document_view_get_spell_checker (self);
#line 255 "../src/document_view.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 255 "../src/document_view.vala"
	spell_checker = _tmp6_;
#line 256 "../src/document_view.vala"
	_tmp7_ = spell_checker;
#line 256 "../src/document_view.vala"
	g_return_if_fail (_tmp7_ != NULL);
#line 258 "../src/document_view.vala"
	_tmp8_ = spell_checker;
#line 258 "../src/document_view.vala"
	_tmp9_ = gspell_checker_get_language (_tmp8_);
#line 258 "../src/document_view.vala"
	if (_tmp9_ != NULL) {
#line 259 "../src/document_view.vala"
		_g_object_unref0 (spell_checker);
#line 259 "../src/document_view.vala"
		_g_object_unref0 (gspell_view);
#line 259 "../src/document_view.vala"
		return;
#line 1284 "document_view.c"
	}
#line 261 "../src/document_view.vala"
	_tmp10_ = gspell_view;
#line 261 "../src/document_view.vala"
	gspell_text_view_set_inline_spell_checking (_tmp10_, FALSE);
#line 263 "../src/document_view.vala"
	if (document_view__no_spell_language_dialog_shown) {
#line 264 "../src/document_view.vala"
		_g_object_unref0 (spell_checker);
#line 264 "../src/document_view.vala"
		_g_object_unref0 (gspell_view);
#line 264 "../src/document_view.vala"
		return;
#line 1298 "document_view.c"
	}
#line 266 "../src/document_view.vala"
	document_view__no_spell_language_dialog_shown = TRUE;
#line 268 "../src/document_view.vala"
	_tmp11_ = tepl_utils_get_toplevel_window ((GtkWidget*) self);
#line 268 "../src/document_view.vala"
	_tmp12_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp11_, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_NONE, "%s", _ ("No dictionaries available for the spell-checking."));
#line 268 "../src/document_view.vala"
	g_object_ref_sink (_tmp12_);
#line 268 "../src/document_view.vala"
	dialog = _tmp12_;
#line 274 "../src/document_view.vala"
	_tmp13_ = dialog;
#line 274 "../src/document_view.vala"
	gtk_dialog_add_buttons ((GtkDialog*) _tmp13_, _ ("_Help"), GTK_RESPONSE_HELP, _ ("_OK"), GTK_RESPONSE_OK, NULL, NULL);
#line 278 "../src/document_view.vala"
	_tmp14_ = dialog;
#line 278 "../src/document_view.vala"
	response = gtk_dialog_run ((GtkDialog*) _tmp14_);
#line 280 "../src/document_view.vala"
	if (response == ((gint) GTK_RESPONSE_HELP)) {
#line 1320 "document_view.c"
		{
#line 284 "../src/document_view.vala"
			gtex_utils_show_uri ((GtkWidget*) self, "help:enter-tex/spell_checking", (guint32) GDK_CURRENT_TIME, &_inner_error0_);
#line 284 "../src/document_view.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1326 "document_view.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
#line 282 "../src/document_view.vala"
			e = _inner_error0_;
#line 282 "../src/document_view.vala"
			_inner_error0_ = NULL;
#line 289 "../src/document_view.vala"
			_tmp15_ = e;
#line 289 "../src/document_view.vala"
			_tmp16_ = _tmp15_->message;
#line 289 "../src/document_view.vala"
			g_warning ("document_view.vala:289: Impossible to open the documentation: %s", _tmp16_);
#line 282 "../src/document_view.vala"
			_g_error_free0 (e);
#line 1348 "document_view.c"
		}
		__finally0:
#line 282 "../src/document_view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 282 "../src/document_view.vala"
			_g_object_unref0 (dialog);
#line 282 "../src/document_view.vala"
			_g_object_unref0 (spell_checker);
#line 282 "../src/document_view.vala"
			_g_object_unref0 (gspell_view);
#line 282 "../src/document_view.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 282 "../src/document_view.vala"
			g_clear_error (&_inner_error0_);
#line 282 "../src/document_view.vala"
			return;
#line 1365 "document_view.c"
		}
	}
#line 293 "../src/document_view.vala"
	_tmp17_ = dialog;
#line 293 "../src/document_view.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp17_);
#line 248 "../src/document_view.vala"
	_g_object_unref0 (dialog);
#line 248 "../src/document_view.vala"
	_g_object_unref0 (spell_checker);
#line 248 "../src/document_view.vala"
	_g_object_unref0 (gspell_view);
#line 1378 "document_view.c"
}

static void
document_view_class_init (DocumentViewClass * klass,
                          gpointer klass_data)
{
#line 7 "../src/document_view.vala"
	document_view_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/document_view.vala"
	g_type_class_adjust_private_offset (klass, &DocumentView_private_offset);
#line 7 "../src/document_view.vala"
	G_OBJECT_CLASS (klass)->finalize = document_view_finalize;
#line 1391 "document_view.c"
}

static void
document_view_instance_init (DocumentView * self,
                             gpointer klass)
{
#line 7 "../src/document_view.vala"
	self->priv = document_view_get_instance_private (self);
#line 1400 "document_view.c"
}

static void
document_view_finalize (GObject * obj)
{
	DocumentView * self;
#line 7 "../src/document_view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DOCUMENT_VIEW, DocumentView);
#line 14 "../src/document_view.vala"
	_g_object_unref0 (self->priv->_editor_settings);
#line 15 "../src/document_view.vala"
	__vala_PangoFontDescription_free0 (self->priv->_font_desc);
#line 7 "../src/document_view.vala"
	G_OBJECT_CLASS (document_view_parent_class)->finalize (obj);
#line 1415 "document_view.c"
}

 G_GNUC_NO_INLINE static GType
document_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DocumentViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) document_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DocumentView), 0, (GInstanceInitFunc) document_view_instance_init, NULL };
	GType document_view_type_id;
	document_view_type_id = g_type_register_static (tepl_view_get_type (), "DocumentView", &g_define_type_info, 0);
	DocumentView_private_offset = g_type_add_instance_private (document_view_type_id, sizeof (DocumentViewPrivate));
	return document_view_type_id;
}

GType
document_view_get_type (void)
{
	static gsize document_view_type_id__once = 0;
	if (g_once_init_enter (&document_view_type_id__once)) {
		GType document_view_type_id;
		document_view_type_id = document_view_get_type_once ();
		g_once_init_leave (&document_view_type_id__once, document_view_type_id);
	}
	return document_view_type_id__once;
}

