/* utils.c generated by valac 0.56.18, the Vala compiler
 * generated from utils.vala, do not modify */

/* SPDX-FileCopyrightText: 2010-2020 Sébastien Wilmet
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <tepl/tepl.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

VALA_EXTERN const gchar* utils_get_string_from_resource (const gchar* resource_path);
VALA_EXTERN void utils_delete_file (GFile* file);
VALA_EXTERN gboolean utils_save_file (GFile* file,
                          const gchar* contents,
                          gboolean make_backup);
VALA_EXTERN gchar* utils_load_file (GFile* file);
VALA_EXTERN GtkScrolledWindow* utils_add_scrollbar (GtkWidget* child);
VALA_EXTERN gint utils_get_selected_row (GtkTreeView* view,
                             GtkTreeIter* iter);
static void _vala_GtkTreePath_free (GtkTreePath* self);
VALA_EXTERN void utils_flush_queue (void);

/*************************************************************************/
const gchar*
utils_get_string_from_resource (const gchar* resource_path)
{
	GError* _inner_error0_ = NULL;
	const gchar* result;
#line 12 "../src/utils.vala"
	g_return_val_if_fail (resource_path != NULL, NULL);
#line 60 "utils.c"
	{
		GBytes* bytes = NULL;
		GBytes* _tmp0_;
		gsize _tmp1_ = 0;
		guint8* _tmp2_;
#line 16 "../src/utils.vala"
		_tmp0_ = g_resources_lookup_data (resource_path, 0, &_inner_error0_);
#line 16 "../src/utils.vala"
		bytes = _tmp0_;
#line 16 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 72 "utils.c"
			goto __catch0_g_error;
		}
#line 17 "../src/utils.vala"
		_tmp2_ = g_bytes_get_data (bytes, &_tmp1_);
#line 17 "../src/utils.vala"
		result = (const gchar*) _tmp2_;
#line 17 "../src/utils.vala"
		_g_bytes_unref0 (bytes);
#line 17 "../src/utils.vala"
		return result;
#line 83 "utils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 14 "../src/utils.vala"
		e = _inner_error0_;
#line 14 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 21 "../src/utils.vala"
		_tmp3_ = e;
#line 21 "../src/utils.vala"
		_tmp4_ = _tmp3_->message;
#line 21 "../src/utils.vala"
		g_warning ("utils.vala:21: Failed to load data from resource '%s': %s", resource_path, _tmp4_);
#line 23 "../src/utils.vala"
		result = NULL;
#line 23 "../src/utils.vala"
		_g_error_free0 (e);
#line 23 "../src/utils.vala"
		return result;
#line 107 "utils.c"
	}
	__finally0:
#line 14 "../src/utils.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 14 "../src/utils.vala"
	g_clear_error (&_inner_error0_);
#line 14 "../src/utils.vala"
	return NULL;
#line 116 "utils.c"
}

/*************************************************************************/
void
utils_delete_file (GFile* file)
{
	GError* _inner_error0_ = NULL;
#line 33 "../src/utils.vala"
	g_return_if_fail (file != NULL);
#line 35 "../src/utils.vala"
	if (!g_file_query_exists (file, NULL)) {
#line 36 "../src/utils.vala"
		return;
#line 130 "utils.c"
	}
	{
#line 40 "../src/utils.vala"
		g_file_delete (file, NULL, &_inner_error0_);
#line 40 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 137 "utils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 38 "../src/utils.vala"
		e = _inner_error0_;
#line 38 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 44 "../src/utils.vala"
		_tmp0_ = g_file_get_parse_name (file);
#line 44 "../src/utils.vala"
		_tmp1_ = _tmp0_;
#line 44 "../src/utils.vala"
		_tmp2_ = e;
#line 44 "../src/utils.vala"
		_tmp3_ = _tmp2_->message;
#line 44 "../src/utils.vala"
		g_warning ("utils.vala:44: Delete file '%s' failed: %s", _tmp1_, _tmp3_);
#line 44 "../src/utils.vala"
		_g_free0 (_tmp1_);
#line 38 "../src/utils.vala"
		_g_error_free0 (e);
#line 167 "utils.c"
	}
	__finally0:
#line 38 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 38 "../src/utils.vala"
		return;
#line 178 "utils.c"
	}
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 216 "utils.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 222 "utils.c"
}

gboolean
utils_save_file (GFile* file,
                 const gchar* contents,
                 gboolean make_backup)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 48 "../src/utils.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 48 "../src/utils.vala"
	g_return_val_if_fail (contents != NULL, FALSE);
#line 236 "utils.c"
	{
		guint8* _tmp0_;
		gint _tmp0__length1;
		gint _tmp1_ = 0;
		guint8* _tmp2_;
		gint _tmp2__length1;
#line 52 "../src/utils.vala"
		tepl_utils_create_parent_directories (file, NULL, &_inner_error0_);
#line 52 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 247 "utils.c"
			goto __catch0_g_error;
		}
#line 54 "../src/utils.vala"
		_tmp0_ = string_get_data (contents, &_tmp1_);
#line 54 "../src/utils.vala"
		_tmp0__length1 = _tmp1_;
#line 54 "../src/utils.vala"
		_tmp2_ = _tmp0_;
#line 54 "../src/utils.vala"
		_tmp2__length1 = _tmp0__length1;
#line 54 "../src/utils.vala"
		g_file_replace_contents (file, (const char*) _tmp2_, (gsize) _tmp2__length1, NULL, make_backup, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error0_);
#line 54 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 262 "utils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 50 "../src/utils.vala"
		e = _inner_error0_;
#line 50 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 59 "../src/utils.vala"
		_tmp3_ = g_file_get_parse_name (file);
#line 59 "../src/utils.vala"
		_tmp4_ = _tmp3_;
#line 59 "../src/utils.vala"
		_tmp5_ = e;
#line 59 "../src/utils.vala"
		_tmp6_ = _tmp5_->message;
#line 59 "../src/utils.vala"
		g_warning ("utils.vala:59: Failed to save the file '%s': %s", _tmp4_, _tmp6_);
#line 59 "../src/utils.vala"
		_g_free0 (_tmp4_);
#line 61 "../src/utils.vala"
		result = FALSE;
#line 61 "../src/utils.vala"
		_g_error_free0 (e);
#line 61 "../src/utils.vala"
		return result;
#line 296 "utils.c"
	}
	__finally0:
#line 50 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 301 "utils.c"
		gboolean _tmp7_ = FALSE;
#line 50 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 50 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 50 "../src/utils.vala"
		return _tmp7_;
#line 309 "utils.c"
	}
#line 64 "../src/utils.vala"
	result = TRUE;
#line 64 "../src/utils.vala"
	return result;
#line 315 "utils.c"
}

gchar*
utils_load_file (GFile* file)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 68 "../src/utils.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 325 "utils.c"
	{
		guint8* chars = NULL;
		gint chars_length1 = 0;
		gint _chars_size_ = 0;
		guint8* _tmp0_ = NULL;
		gsize _tmp1_ = 0;
		guint8* _tmp2_;
		gint _tmp2__length1;
#line 73 "../src/utils.vala"
		g_file_load_contents (file, NULL, &_tmp0_, &_tmp1_, NULL, &_inner_error0_);
#line 73 "../src/utils.vala"
		chars = (g_free (chars), NULL);
#line 73 "../src/utils.vala"
		chars = _tmp0_;
#line 73 "../src/utils.vala"
		chars_length1 = _tmp1_;
#line 73 "../src/utils.vala"
		_chars_size_ = chars_length1;
#line 73 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../src/utils.vala"
			chars = (g_free (chars), NULL);
#line 348 "utils.c"
			goto __catch0_g_error;
		}
#line 74 "../src/utils.vala"
		_tmp2_ = chars;
#line 74 "../src/utils.vala"
		_tmp2__length1 = chars_length1;
#line 74 "../src/utils.vala"
		chars = NULL;
#line 74 "../src/utils.vala"
		chars_length1 = 0;
#line 74 "../src/utils.vala"
		result = (gchar*) _tmp2_;
#line 74 "../src/utils.vala"
		chars = (g_free (chars), NULL);
#line 74 "../src/utils.vala"
		return result;
#line 365 "utils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 70 "../src/utils.vala"
		e = _inner_error0_;
#line 70 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 78 "../src/utils.vala"
		_tmp3_ = g_file_get_parse_name (file);
#line 78 "../src/utils.vala"
		_tmp4_ = _tmp3_;
#line 78 "../src/utils.vala"
		_tmp5_ = e;
#line 78 "../src/utils.vala"
		_tmp6_ = _tmp5_->message;
#line 78 "../src/utils.vala"
		g_warning ("utils.vala:78: Failed to load the file '%s': %s", _tmp4_, _tmp6_);
#line 78 "../src/utils.vala"
		_g_free0 (_tmp4_);
#line 80 "../src/utils.vala"
		result = NULL;
#line 80 "../src/utils.vala"
		_g_error_free0 (e);
#line 80 "../src/utils.vala"
		return result;
#line 397 "utils.c"
	}
	__finally0:
#line 70 "../src/utils.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../src/utils.vala"
	g_clear_error (&_inner_error0_);
#line 70 "../src/utils.vala"
	return NULL;
#line 406 "utils.c"
}

/*************************************************************************/
GtkScrolledWindow*
utils_add_scrollbar (GtkWidget* child)
{
	GtkScrolledWindow* sw = NULL;
	GtkScrolledWindow* _tmp0_;
	GtkScrolledWindow* result;
#line 88 "../src/utils.vala"
	g_return_val_if_fail (child != NULL, NULL);
#line 90 "../src/utils.vala"
	_tmp0_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 90 "../src/utils.vala"
	g_object_ref_sink (_tmp0_);
#line 90 "../src/utils.vala"
	sw = _tmp0_;
#line 91 "../src/utils.vala"
	gtk_container_add ((GtkContainer*) sw, child);
#line 92 "../src/utils.vala"
	result = sw;
#line 92 "../src/utils.vala"
	return result;
#line 430 "utils.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 99 "../src/utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 438 "utils.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 104 "../src/utils.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 446 "utils.c"
}

gint
utils_get_selected_row (GtkTreeView* view,
                        GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	GtkTreeSelection* select = NULL;
	GtkTreeSelection* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	gboolean _tmp4_;
	gint result;
#line 97 "../src/utils.vala"
	g_return_val_if_fail (view != NULL, 0);
#line 99 "../src/utils.vala"
	_tmp0_ = gtk_tree_view_get_selection (view);
#line 99 "../src/utils.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 99 "../src/utils.vala"
	select = _tmp1_;
#line 100 "../src/utils.vala"
	_tmp2_ = select;
#line 100 "../src/utils.vala"
	_tmp4_ = gtk_tree_selection_get_selected (_tmp2_, NULL, &_tmp3_);
#line 100 "../src/utils.vala"
	_vala_iter = _tmp3_;
#line 100 "../src/utils.vala"
	if (_tmp4_) {
#line 477 "utils.c"
		GtkTreeModel* model = NULL;
		GtkTreeModel* _tmp5_;
		GtkTreeModel* _tmp6_;
		GtkTreePath* path = NULL;
		GtkTreeModel* _tmp7_;
		GtkTreeIter _tmp8_;
		GtkTreePath* _tmp9_;
		GtkTreePath* _tmp10_;
		gint _tmp11_ = 0;
		gint* _tmp12_;
		gint _tmp13_;
#line 102 "../src/utils.vala"
		_tmp5_ = gtk_tree_view_get_model (view);
#line 102 "../src/utils.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 102 "../src/utils.vala"
		model = _tmp6_;
#line 103 "../src/utils.vala"
		_tmp7_ = model;
#line 103 "../src/utils.vala"
		_tmp8_ = _vala_iter;
#line 103 "../src/utils.vala"
		_tmp9_ = gtk_tree_model_get_path (_tmp7_, &_tmp8_);
#line 103 "../src/utils.vala"
		path = _tmp9_;
#line 104 "../src/utils.vala"
		_tmp10_ = path;
#line 104 "../src/utils.vala"
		_tmp12_ = gtk_tree_path_get_indices_with_depth (_tmp10_, &_tmp11_);
#line 104 "../src/utils.vala"
		_tmp13_ = _tmp12_[0];
#line 104 "../src/utils.vala"
		result = _tmp13_;
#line 104 "../src/utils.vala"
		__vala_GtkTreePath_free0 (path);
#line 104 "../src/utils.vala"
		_g_object_unref0 (model);
#line 104 "../src/utils.vala"
		_g_object_unref0 (select);
#line 104 "../src/utils.vala"
		if (iter) {
#line 104 "../src/utils.vala"
			*iter = _vala_iter;
#line 521 "utils.c"
		}
#line 104 "../src/utils.vala"
		return result;
#line 525 "utils.c"
	}
#line 106 "../src/utils.vala"
	result = -1;
#line 106 "../src/utils.vala"
	_g_object_unref0 (select);
#line 106 "../src/utils.vala"
	if (iter) {
#line 106 "../src/utils.vala"
		*iter = _vala_iter;
#line 535 "utils.c"
	}
#line 106 "../src/utils.vala"
	return result;
#line 539 "utils.c"
}

/*************************************************************************/
void
utils_flush_queue (void)
{
#line 118 "../src/utils.vala"
	while (TRUE) {
#line 118 "../src/utils.vala"
		if (!gtk_events_pending ()) {
#line 118 "../src/utils.vala"
			break;
#line 552 "utils.c"
		}
#line 119 "../src/utils.vala"
		gtk_main_iteration ();
#line 556 "utils.c"
	}
}

